/*
Rewards API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package rewardsapi

import (
	"encoding/json"
)

// checks if the SweepstakeParticipant type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SweepstakeParticipant{}

// SweepstakeParticipant struct for SweepstakeParticipant
type SweepstakeParticipant struct {
	Id string `json:"id"`
	Name string `json:"name"`
	TransactionId string `json:"transaction_id"`
	ContactId string `json:"contact_id"`
	InteractionId string `json:"interaction_id"`
	WonPrizes []string `json:"won_prizes"`
	ChannelId string `json:"channel_id"`
	ConversationId string `json:"conversation_id"`
	CreatedAt string `json:"created_at"`
}

// NewSweepstakeParticipant instantiates a new SweepstakeParticipant object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSweepstakeParticipant(id string, name string, transactionId string, contactId string, interactionId string, wonPrizes []string, channelId string, conversationId string, createdAt string) *SweepstakeParticipant {
	this := SweepstakeParticipant{}
	this.Id = id
	this.Name = name
	this.TransactionId = transactionId
	this.ContactId = contactId
	this.InteractionId = interactionId
	this.WonPrizes = wonPrizes
	this.ChannelId = channelId
	this.ConversationId = conversationId
	this.CreatedAt = createdAt
	return &this
}

// NewSweepstakeParticipantWithDefaults instantiates a new SweepstakeParticipant object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSweepstakeParticipantWithDefaults() *SweepstakeParticipant {
	this := SweepstakeParticipant{}
	return &this
}

// GetId returns the Id field value
func (o *SweepstakeParticipant) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *SweepstakeParticipant) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *SweepstakeParticipant) SetId(v string) {
	o.Id = v
}

// GetName returns the Name field value
func (o *SweepstakeParticipant) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *SweepstakeParticipant) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *SweepstakeParticipant) SetName(v string) {
	o.Name = v
}

// GetTransactionId returns the TransactionId field value
func (o *SweepstakeParticipant) GetTransactionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value
// and a boolean to check if the value has been set.
func (o *SweepstakeParticipant) GetTransactionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TransactionId, true
}

// SetTransactionId sets field value
func (o *SweepstakeParticipant) SetTransactionId(v string) {
	o.TransactionId = v
}

// GetContactId returns the ContactId field value
func (o *SweepstakeParticipant) GetContactId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value
// and a boolean to check if the value has been set.
func (o *SweepstakeParticipant) GetContactIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactId, true
}

// SetContactId sets field value
func (o *SweepstakeParticipant) SetContactId(v string) {
	o.ContactId = v
}

// GetInteractionId returns the InteractionId field value
func (o *SweepstakeParticipant) GetInteractionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value
// and a boolean to check if the value has been set.
func (o *SweepstakeParticipant) GetInteractionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.InteractionId, true
}

// SetInteractionId sets field value
func (o *SweepstakeParticipant) SetInteractionId(v string) {
	o.InteractionId = v
}

// GetWonPrizes returns the WonPrizes field value
func (o *SweepstakeParticipant) GetWonPrizes() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.WonPrizes
}

// GetWonPrizesOk returns a tuple with the WonPrizes field value
// and a boolean to check if the value has been set.
func (o *SweepstakeParticipant) GetWonPrizesOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.WonPrizes, true
}

// SetWonPrizes sets field value
func (o *SweepstakeParticipant) SetWonPrizes(v []string) {
	o.WonPrizes = v
}

// GetChannelId returns the ChannelId field value
func (o *SweepstakeParticipant) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *SweepstakeParticipant) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *SweepstakeParticipant) SetChannelId(v string) {
	o.ChannelId = v
}

// GetConversationId returns the ConversationId field value
func (o *SweepstakeParticipant) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *SweepstakeParticipant) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *SweepstakeParticipant) SetConversationId(v string) {
	o.ConversationId = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *SweepstakeParticipant) GetCreatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *SweepstakeParticipant) GetCreatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *SweepstakeParticipant) SetCreatedAt(v string) {
	o.CreatedAt = v
}

func (o SweepstakeParticipant) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SweepstakeParticipant) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["name"] = o.Name
	toSerialize["transaction_id"] = o.TransactionId
	toSerialize["contact_id"] = o.ContactId
	toSerialize["interaction_id"] = o.InteractionId
	toSerialize["won_prizes"] = o.WonPrizes
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["conversation_id"] = o.ConversationId
	toSerialize["created_at"] = o.CreatedAt
	return toSerialize, nil
}

type NullableSweepstakeParticipant struct {
	value *SweepstakeParticipant
	isSet bool
}

func (v NullableSweepstakeParticipant) Get() *SweepstakeParticipant {
	return v.value
}

func (v *NullableSweepstakeParticipant) Set(val *SweepstakeParticipant) {
	v.value = val
	v.isSet = true
}

func (v NullableSweepstakeParticipant) IsSet() bool {
	return v.isSet
}

func (v *NullableSweepstakeParticipant) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSweepstakeParticipant(val *SweepstakeParticipant) *NullableSweepstakeParticipant {
	return &NullableSweepstakeParticipant{value: val, isSet: true}
}

func (v NullableSweepstakeParticipant) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSweepstakeParticipant) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


